#######################################################################
# Project	: MacPerl		-
# File		: Makefile.mk		-	dmake Makefile for MacPerl
# Author	: Matthias Neeracher
# Started	: 22Apr96								Language	:	dmake
# Modified	: 22Apr96 MN	Compiles correctly
# Last		: 22Apr96
#######################################################################

PERL_SRC = ::perl5.002:

.INCLUDE : $(PERL_SRC)BuildRules.mk

COpt += -i $(PERL_SRC) -d MALLOC_LOG -w nopossible

MacPerlSources	=		\
	MPUtils.c		\
	MPAEUtils.c		\
	MPAppleEvents.c		\
	MPGlobals.c		\
	MPEditions.c		\
	MPFile.c		\
	MPMain.c		\
	MPEditor.c		\
	MPWindow.c		\
	MPConsole.cp		\
	MPAEVTStream.cp		\
	MPHelp.c		\
	MPScript.c		\
	MPPseudoFile.cp		\
	MPSave.c		\
	MPPreferences.c		\
	MercutioAPI.c

.SOURCE : $(PERL_SRC)

PerlSources = runperl.c

Objects68K = {$(MacPerlSources) $(PerlSources)}.68K.o
Objects680 = {$(MacPerlSources) $(PerlSources)}.680.o
ObjectsPPC = {$(MacPerlSources) $(PerlSources)}.PPC.o
BigObjects68K = $(Objects68K:s/runperl.c.68K.o/runbigperl.c.o.68K/)

Static_Ext		= 	MacPerl:MacPerl 	\
				DynaLoader:DynaLoader 	\
				NDBM_File:NDBM_File	\
				DB_File:DB_File		\
				Socket:Socket		\
				Fcntl:Fcntl		\
				Safe:Safe		\
				POSIX:POSIX		\
				IO:IO			\
				UNIVERSAL:UNIVERSAL
Big_Static_Ext		=	$(Static_Ext) Mac:Mac GD-1.00:GD
Static_Ext_AutoInit_PPC	=	$(PERL_SRC)ext:{$(Static_Ext)}.Lib.PPC
Static_Ext_AutoInit_68K	=	$(PERL_SRC)ext:{$(Static_Ext)}.Lib.68K
Big_Static_Ext_AutoInit_68K =	$(PERL_SRC)ext:{$(Big_Static_Ext)}.Lib.68K

PerlObj68K	=				\
	$(PERL_SRC)PLib:PerlLib.68K.Lib		\
	$(PERL_SRC)PLib:Perl.68K.Lib		\
	$(Static_Ext_AutoInit_68K)

PerlObjPPC	=				\
	$(PERL_SRC)PLib:PerlLib.PPC.Lib		\
	$(PERL_SRC)PLib:Perl.PPC.Lib		\
	$(Static_Ext_AutoInit_PPC)

BigPerlObj68K	=				\
	$(PERL_SRC)PLib:PerlLib.68K.Lib		\
	$(PERL_SRC)PLib:Perl.68K.Lib		\
	$(Big_Static_Ext_AutoInit_68K)

MacPerlLib68K	=					\
	"{{MW68KLibraries}}GUSIDispatch.Lib.68K"	\
	"{{MW68KLibraries}}ANSI (N/4i/8d) C.68K.Lib"	\
	"{{MW68KLibraries}}MathLib68K (4i/8d).Lib"	\
	"{{MW68KLibraries}}GUSI.Lib.68K"		\
	"{{MW68KLibraries}}MacOS.Lib"			\
	"{{MW68KLibraries}}ICGlue.o"			\
	"{{MW68KLibraries}}AEObjectSupportLib.o"	\
	"{{MW68KLibraries}}CPlusPlus.lib"		\
	"{{MW68KLibraries}}MPWRuntime.68K.Lib"		\
	"{{MW68KLibraries}}ToolLibs.o"			\
	"{{MW68KLibraries}}PLStringFuncs.glue.lib"	\
	"{{MW68KLibraries}}AEGizmos M/4i"		\
	"{{MW68KLibraries}}db.Lib.68K"			\
	"{{MW68KLibraries}}XL.Lib.68K"			\
	"{{MW68KLibraries}}OSACompLib.o"

BigMacPerlLib68K =	"{{MW68KLibraries}}GD.68K.Lib"

MacPerlLibPPC	=					\
	"{{MWPPCLibraries}}GUSI.Lib.PPC"		\
	"{{MWPPCLibraries}}MWCRuntime.Lib"		\
	"{{MWPPCLibraries}}InterfaceLib"		\
	"{{MWPPCLibraries}}ANSI (NL) C.PPC.Lib"		\
	"{{MWPPCLibraries}}StdCLib"			\
	"{{MWPPCLibraries}}MathLib"			\
	"{{MWPPCLibraries}}PPCToolLibs.o"		\
	"{{MWPPCLibraries}}AEGizmosPPC.lib"		\
	"{{MWPPCLibraries}}db.Lib.PPC"			\
	"{{MWPPCLibraries}}XL.Lib.PPC"			\
	"{{MWPPCLibraries}}ObjectSupportLib"		\
	"{{MWPPCLibraries}}ICGluePPC.Lib"		\
	"{{MWPPCLibraries}}"x80.o			\
	"{{MWPPCLibraries}}AppleScriptLib"
	
all	: MPObj MacPerl BigMacPerl "MacPerl Help" MacPerlTest.Script MPDroplet

clean	:	
	Delete :Obj:

realclean	:	clean
	Delete MacPerl MacPerl.PPC MacPerl.68K

MacPerl.PPC : ObjectsPPC $(PerlObjPPC)
	$(ApplLinkPPC) -name Perl -export all -o MacPerl.PPC :Obj:{$(ObjectsPPC)} $(PerlObjPPC) $(MacPerlLibPPC)
MacPerl.PPC	::	MacPerl.r MacPerl.rsrc MPTerminology.r MPBalloons.r :Obj:FontLDEF.rsrc
	Rez -a -t APPL -c McPL MacPerl.r -d APPNAME="Perl" -o MacPerl.PPC
	SetFile -a B MacPerl.PPC

MacPerl.68K : Objects68K $(PerlObj68K)
	$(ApplLink68K) -o MacPerl.68K :Obj:{$(Objects68K)} $(PerlObj68K) $(MacPerlLib68K)
MacPerl.68K	::	MacPerl.r MacPerl.rsrc MPTerminology.r MPBalloons.r :Obj:FontLDEF.rsrc
	Rez -a -t APPL -c McPL MacPerl.r -o MacPerl.68K
	SetFile -a B MacPerl.68K

MacPerl : MacPerl.PPC MacPerl.68K
	Duplicate -y MacPerl.PPC MacPerl
	Echo 'Include "MacPerl.68K" '''CODE''';'	
		  'Include "MacPerl.68K" '''DATA''';'	
		| Rez -a -c McPL -t APPL -o MacPerl
	::Perl5.002:UnPreload MacPerl

BigMacPerl : Objects68K $(BigPerlObj68K) runbigperl.c.o.68K
	$(ApplLink68K) -o BigMacPerl :Obj:{$(BigObjects68K)} $(BigPerlObj68K) $(MacPerlLib68K) $(BigMacPerlLib68K)
BigMacPerl	::	MacPerl.r MacPerl.rsrc MPTerminology.r MPBalloons.r :Obj:FontLDEF.rsrc
	Rez -a -t APPL -c McPL MacPerl.r -o BigMacPerl
	SetFile -a B BigMacPerl

":Obj:FontLDEF.rsrc" : MPFontLDEF.c.o.68K
	$(RsrcLink68K) -t rsrc -c RSED -rt LDEF=128 -o :Obj:FontLDEF.rsrc 	
		:Obj:MPFontLDEF.c.o.68K "{{MW68KLibraries}}"MacOS.lib

MPTerminology.r	:	MPTerminology.aete
	:macscripts:Aete2Rez MPTerminology.aete > MPTerminology.r

MPBalloons.r	:	MPBalloons.ball
	:macscripts:Balloon2Rez MPBalloons.ball

MPGlobals.c.PPC.o	:	MPGlobals.h
MPGlobals.c.68K.o	:	MPGlobals.h

"HTML Help" 		:	MacPerl.help
	BuildHelpIndex	"HTML Help" MacPerl.help
"MacPerl Help" 		:	MacPerl.podhelp
	BuildHelpIndex	"MacPerl Help" MacPerl.podhelp

MacPerlTest.Script	:	MakeMacPerlTest
	MakeMacPerlTest 
		:t:base:.t :t:comp:.t :t:cmd:.t :t:io:.t	
		:t:op:.t :t:lib:.t > MacPerlTest.Script

MPDroplet.code : MPDrop.c.o.68K
	$(ApplLink68K) -t 'rsrc' -c 'RSED' -sym on		
		MPDrop.c.o.68K					
		"{{MW68KLibraries}}ANSIFa(N/4i/8d)C.68K.Lib"	
		"{{MW68KLibraries}}MathLib68K Fa(4i/8d).Lib"	
		"{{MW68KLibraries}}MacOS.Lib" -o MPDroplet.code	

MPDroplet : ":MacPerl Extensions:Droplet"	

":MacPerl Extensions:Droplet" : MPDroplet.code MPDroplet.r MPExtension.r MacPerl.rsrc
	Rez -t McPp -c McPL -o ":MacPerl Extensions:Droplet" MPDroplet.r
		
Distr : all
	Distribute MacPerl.distr Mac_Perl_510r2_appl.sit

MPObj :
	NewFolder Obj
	echo > MPObj

.INCLUDE : $(PERL_SRC)BulkBuildRules.mk
