/* dl_dlopen.xs
 * 
 * Platform:	Macintosh CFM
 * Author:	Matthias Neeracher <neeri@iis.ee.ethz.ch>
 *		Adapted from dl_dlopen.xs reference implementation by
 *              Paul Marquess (pmarquess@bfsec.bt.co.uk)
 * $Log$
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <CodeFragments.h>


#include "dlutils.c"	/* SaveError() etc	*/

static ConnectionID **	connections;

void CopyC2PStr(char * cstr, StringPtr pstr);

static void terminate(void)
{
    int size = GetHandleSize((Handle) connections) / sizeof(ConnectionID);
    HLock((Handle) connections);
    while (size)
    	CloseConnection(*connections + --size);
    DisposeHandle((Handle) connections);
    connections = nil;
}

static void
dl_private_init()
{
    (void)dl_generic_private_init();
}

MODULE = DynaLoader	PACKAGE = DynaLoader

BOOT:
    (void)dl_private_init();


ConnectionID
dl_load_file(filename)
    char *		filename
    CODE:
    OSErr		err;
    FSSpec		spec;
    ConnectionID	connID;
    Ptr			mainAddr;
    Str255		errName;
    DLDEBUG(1,fprintf(stderr,"dl_load_file(%s):\n", filename));
    err = Path2FSSpec(filename, &spec);
    if (!err)
    	err = 
	    GetDiskFragment(
	    	&spec, 0, 0, spec.name, kLoadLib, &connID, &mainAddr, errName);
    if (!err) {
    	if (!connections) {
	    connections = (ConnectionID **)NewHandle(0);
	    atexit(terminate);
	}
	PtrAndHand((Ptr) &connID, (Handle) connections, sizeof(ConnectionID));
    	RETVAL = connID;
    } else
     	RETVAL = (ConnectionID) 0;
    DLDEBUG(2,fprintf(stderr," libref=%d\n", RETVAL));
    ST(0) = sv_newmortal() ;
    if (err)
	SaveError("DynaLoader error [%d, %#s]", err, errName) ;
    else
	sv_setiv( ST(0), (IV)RETVAL);


void *
dl_find_symbol(connID, symbolname)
    ConnectionID	connID
    char *		symbolname
    CODE:
    OSErr		err;
    Str255		symbol;
    Ptr			symAddr;
    SymClass		symClass;
    DLDEBUG(2,fprintf(stderr,"dl_find_symbol(handle=%x, symbol=%s)\n",
	connID, symbolname));
    CopyC2PStr(symbolname, symbol);
    err = FindSymbol(connID, symbol, &symAddr, &symClass);
    if (err)
    	symAddr = (Ptr) 0;
    RETVAL = (void *) symAddr;
    DLDEBUG(2,fprintf(stderr,"  symbolref = %x\n", RETVAL));
    ST(0) = sv_newmortal() ;
    if (err)
	SaveError("DynaLoader error [%d]!", err) ;
    else
	sv_setiv( ST(0), (IV)RETVAL);


void
dl_undef_symbols()
    PPCODE:



# These functions should not need changing on any platform:

void
dl_install_xsub(perl_name, symref, filename="$Package")
    char *		perl_name
    void *		symref 
    char *		filename
    CODE:
    DLDEBUG(2,fprintf(stderr,"dl_install_xsub(name=%s, symref=%x)\n",
		perl_name, symref));
    ST(0)=sv_2mortal(newRV((SV*)newXS(perl_name, (void(*)())symref, filename)));


char *
dl_error()
    CODE:
    RETVAL = LastError ;
    OUTPUT:
    RETVAL

# end.
