package Mac::Components;

=head1 NAME

Mac::Components - Macintosh Toolbox Interface to the Components Manager

=head1 SYNOPSIS


	use Mac::Components;
	RegisterComponentResource($Resource, 1);
	OpenComponent($Component);
	CloseComponent($Component);

=head1 DESCRIPTION


=include Components.XS

=head1 FILES

=head1 AUTHOR(S)

Matthias Ulrich Neeracher <neeri@iis.ee.ethz.ch> Author

Bob Dalgleish <bob.dalgleish@sasknet.sk.ca> Documenter

=cut

require Exporter;
require DynaLoader;
@ISA = (Exporter, DynaLoader);
@EXPORT = qw(
	RegisterComponentResource
	UnregisterComponent
	FindNextComponent
	CountComponents
	GetComponentInfo
	GetComponentListModSeed
	OpenComponent
	CloseComponent
	GetComponentInstanceError
	ComponentFunctionImplemented
	SetDefaultComponent
	OpenDefaultComponent
	RegisterComponentResourceFile
	kAppleManufacturer
	kComponentResourceType
	kAnyComponentType
	kAnyComponentSubType
	kAnyComponentManufacturer
	kAnyComponentFlagsMask
	kComponentOpenSelect
	kComponentCloseSelect
	kComponentCanDoSelect
	kComponentVersionSelect
	kComponentRegisterSelect
	kComponentTargetSelect
	kComponentUnregisterSelect
	defaultComponentIdentical
	defaultComponentAnyFlags
	defaultComponentAnyManufacturer
	defaultComponentAnySubType
	defaultComponentAnyFlagsAnyManufacturer
	defaultComponentAnyFlagsAnyManufacturerAnySubType
	registerComponentGlobal
	registerComponentNoDuplicates
	registerComponentAfterExisting
);

bootstrap Mac::Components;

sub kAppleManufacturer ()          {     'appl'; }
sub kComponentResourceType ()      {     'thng'; }
sub kAnyComponentType ()           {          0; }
sub kAnyComponentSubType ()        {          0; }
sub kAnyComponentManufacturer ()   {          0; }
sub kAnyComponentFlagsMask ()      {          0; }

sub kComponentOpenSelect ()        {         -1; }
sub kComponentCloseSelect ()       {         -2; }
sub kComponentCanDoSelect ()       {         -3; }
sub kComponentVersionSelect ()     {         -4; }
sub kComponentRegisterSelect ()    {         -5; }
sub kComponentTargetSelect ()      {         -6; }
sub kComponentUnregisterSelect ()  {         -7; }

sub defaultComponentIdentical ()   		{          0; }
sub defaultComponentAnyFlags ()    		{          1; }
sub defaultComponentAnyManufacturer ()	{          2; }
sub defaultComponentAnySubType ()  		{          4; }
sub defaultComponentAnyFlagsAnyManufacturer () { (defaultComponentAnyFlags + defaultComponentAnyManufacturer); }
sub defaultComponentAnyFlagsAnyManufacturerAnySubType () { (defaultComponentAnyFlags + defaultComponentAnyManufacturer + defaultComponentAnySubType); }

sub registerComponentGlobal ()     	  {          1; }
sub registerComponentNoDuplicates ()  {          2; }
sub registerComponentAfterExisting () {          4; }

1;

__END__
