package Mac::Files;

=head1 NAME

Mac::Files - Macintosh Toolbox Interface to the File and Alias Manager

=head1 SYNOPSIS


=head1 DESCRIPTION


=include Files.xs

=cut

require Exporter;
require DynaLoader;
@ISA = (Exporter, DynaLoader);
@EXPORT = qw(
	FSpGetCatInfo
	FSpSetCatInfo
	FSMakeFSSpec
	FSpCreate
	FSpDirCreate
	FSpDelete
	FSpGetFInfo
	FSpGetFInfo
	FSpSetFLock
	FSpGetFInfo
	FSpRename
	FSpCatMove
	FSpExchangeFiles
	NewAlias
	NewAliasRelative
	NewAliasMinimal
	FindFolder
	kOnSystemDisk
	kCreateFolder
	kDontCreateFolder
	kSystemFolderType
	kDesktopFolderType
	kTrashFolderType
	kWhereToEmptyTrashFolderType
	kPrintMonitorDocsFolderType
	kStartupFolderType
	kShutdownFolderType
	kAppleMenuFolderType
	kControlPanelFolderType
	kExtensionFolderType
	kFontsFolderType
	kPreferencesFolderType
	kTemporaryFolderType
);

bootstrap Mac::Files;

sub kOnSystemDisk ()               {     0x8000; }
sub kCreateFolder ()               {          1; }
sub kDontCreateFolder ()           {          0; }

=over 4

=item kSystemFolderType

the system folder.

=cut
sub kSystemFolderType ()           {     'macs'; }

=item kDesktopFolderType

the desktop.

=cut
sub kDesktopFolderType ()          {     'desk'; }

=item kTrashFolderType

the trash.

=cut
sub kTrashFolderType ()            {     'trsh'; }
sub kWhereToEmptyTrashFolderType () {    'empt'; }
sub kPrintMonitorDocsFolderType () {     'prnt'; }

=item kStartupFolderType

the startup items folder.

=cut
sub kStartupFolderType ()          {     'strt'; }

=item kShutdownFolderType

the shutdown items folder.

=cut
sub kShutdownFolderType ()         {     'shdf'; }

=item kAppleMenuFolderType

the apple menu folder.

=cut
sub kAppleMenuFolderType ()        {     'amnu'; }

=item kControlPanelFolderType

the control panels folder.

=cut
sub kControlPanelFolderType ()     {     'ctrl'; }

=item kExtensionFolderType

the extensions folder.

=cut
sub kExtensionFolderType ()        {     'extn'; }

=item kFontsFolderType

the fonts folder.

=cut
sub kFontsFolderType ()            {     'font'; }

=item kPreferencesFolderType

the preferences folder.

=cut
sub kPreferencesFolderType ()      {     'pref'; }

=item kTemporaryFolderType

the temporary items folder.

=back

=cut
sub kTemporaryFolderType ()        {     'temp'; }

=head1 AUTHOR

Matthias Ulrich Neeracher <neeri@iis.ee.ethz.ch>

=cut

1;

__END__
