/* $Header: tyrathect:Development:Perl::RCS:missing.c,v 1.2 1994/05/04 02:12:43 neeri Exp $
 *
 *    Copyright (c) 1996 Matthias Neeracher
 *
 *    You may distribute under the terms of the Perl Artistic License,
 *    as specified in the README file.
 *
 * $Log: missing.c,v $
 */

#define MAC_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <Types.h>
#include <Memory.h>
#include <Resources.h>

#define ResErrorReturn	\
	ST(0) = sv_newmortal();					\
	if (!(gLastMacOSErr = ResError()))	\
		sv_setiv(ST(0), 1);

#define ResErrorCheck						\
	if (gLastMacOSErr = ResError()) {	\
		XSRETURN_UNDEF;						\
	} else 0 	

#define ResErrorCheckRetval				\
	if (RETVAL == -1) {						\
		gLastMacOSErr = ResError();		\
		XSRETURN_UNDEF;						\
	} else 0

#define ResErrorCheckRetvalNULL			\
	if (!RETVAL) {								\
		gLastMacOSErr = ResError();		\
		XSRETURN_UNDEF;						\
	} else 0

MODULE = Mac::Resources	PACKAGE = Mac::Resources

void
CloseResFile(refNum)
	short	refNum

short
CurResFile()

short
HomeResFile(theResource)
	Handle	theResource
	CLEANUP:
	ResErrorCheckRetval;

void
CreateResFile(fileName)
	Str255	fileName
	CLEANUP:
	ResErrorReturn;

short
OpenResFile(fileName)
	Str255	fileName
	CLEANUP:
	ResErrorCheckRetval;

void
UseResFile(refNum)
	short	refNum
	CLEANUP:
	ResErrorReturn;

short
CountTypes()

short
Count1Types()

OSType
GetIndType(index)
	short	index
	CODE:
	GetIndType(&RETVAL, index);
	OUTPUT:
	RETVAL
	CLEANUP:
	ResErrorCheckRetvalNULL;

OSType
Get1IndType(index)
	short	index
	CODE:
	Get1IndType(&RETVAL, index);
	OUTPUT:
	RETVAL
	CLEANUP:
	ResErrorCheckRetvalNULL;

void
SetResLoad(load)
	Boolean	load

short
CountResources(theType)
	OSType	theType

short
Count1Resources(theType)
	OSType	theType

Handle
GetIndResource(theType, index)
	OSType	theType
	short	index
	CLEANUP:
	ResErrorCheckRetvalNULL;

Handle
Get1IndResource(theType, index)
	OSType	theType
	short	index
	CLEANUP:
	ResErrorCheckRetvalNULL;

Handle
GetResource(theType, theID)
	OSType	theType
	short	theID
	CLEANUP:
	ResErrorCheckRetvalNULL;

Handle
Get1Resource(theType, theID)
	OSType	theType
	short	theID
	CLEANUP:
	ResErrorCheckRetvalNULL;

Handle
GetNamedResource(theType, name)
	OSType	theType
	Str255	name
	CLEANUP:
	ResErrorCheckRetvalNULL;

Handle
Get1NamedResource(theType, name)
	OSType	theType
	Str255	name
	CLEANUP:
	ResErrorCheckRetvalNULL;

void
LoadResource(theResource)
	Handle	theResource
	CLEANUP:
	ResErrorReturn;

void
ReleaseResource(theResource)
	Handle	theResource
	CLEANUP:
	ResErrorReturn;

void
DetachResource(theResource)
	Handle	theResource
	CLEANUP:
	ResErrorReturn;

short
UniqueID(theType)
	OSType	theType

short
Unique1ID(theType)
	OSType	theType

short
GetResAttrs(theResource)
	Handle	theResource
	CLEANUP:
	ResErrorCheck;

void
GetResInfo(theResource)
	Handle	theResource
	PPCODE:
	{
		short		theID;
		OSType	theType;
		Str255	name;
		
		GetResInfo(theResource, &theID, &theType, name);
		ResErrorCheck;

		EXTEND(sp, 3);
		PUSHs(sv_2mortal(newSViv(theID)));
		PUSHs(sv_2mortal(newSVpv((char *)&theType, 4)));
		if (*name)
			PUSHs(sv_2mortal(newSVpv((char *)name+1, *name)));
	}

void
SetResInfo(theResource, theID, name)
	Handle	theResource
	short	theID
	Str255	name
	CLEANUP:
	ResErrorReturn;

void
AddResource(theData, theType, theID, name)
	Handle	theData
	OSType	theType
	short	theID
	Str255	name
	CLEANUP:
	ResErrorReturn;

long
GetResourceSizeOnDisk(theResource)
	Handle	theResource
	CLEANUP:
	ResErrorCheckRetval;

long
GetMaxResourceSize(theResource)
	Handle	theResource
	CLEANUP:
	ResErrorCheckRetval;

long
RsrcMapEntry(theResource)
	Handle	theResource
	CLEANUP:
	ResErrorCheckRetvalNULL;

void
SetResAttrs(theResource, attrs)
	Handle	theResource
	short	attrs
	CLEANUP:
	ResErrorReturn;

void
ChangedResource(theResource)
	Handle	theResource
	CLEANUP:
	ResErrorReturn;

void
RemoveResource(theResource)
	Handle	theResource
	CLEANUP:
	ResErrorReturn;

void
UpdateResFile(refNum)
	short	refNum
	CLEANUP:
	ResErrorReturn;

void
WriteResource(theResource)
	Handle	theResource
	CLEANUP:
	ResErrorReturn;

void
SetResPurge(install)
	Boolean	install
	CLEANUP:
	ResErrorReturn;

short
GetResFileAttrs(refNum)
	short	refNum
	CLEANUP:
	ResErrorCheck;

void
SetResFileAttrs(refNum, attrs)
	short	refNum
	short	attrs
	CLEANUP:
	ResErrorReturn;

short
OpenRFPerm(fileName, vRefNum, permission)
	Str255	fileName
	short	vRefNum
	SInt8	permission
	CLEANUP:
	ResErrorCheckRetval;

Handle
RGetResource(theType, theID)
	OSType	theType
	short	theID
	CLEANUP:
	ResErrorCheckRetvalNULL;

short
FSpOpenResFile(spec, permission)
	FSSpec	&spec
	SInt8	permission
	CLEANUP:
	ResErrorCheckRetval;

void
FSpCreateResFile(spec, creator, fileType, scriptTag)
	FSSpec		&spec
	OSType		creator
	OSType		fileType
	SInt8			scriptTag
	CLEANUP:
	ResErrorReturn;

void
ReadPartialResource(theResource, offset, buffer, count)
	Handle	theResource
	long	offset
	void *	buffer
	long	count

void
WritePartialResource(theResource, offset, buffer, count)
	Handle	theResource
	long	offset
	void *	buffer
	long	count
	CLEANUP:
	ResErrorReturn;

void
SetResourceSize(theResource, newSize)
	Handle	theResource
	long	newSize
	CLEANUP:
	ResErrorReturn;

